# Generated automatically -- do not modify!    -*- buffer-read-only: t -*-
# Spec file for Open vSwitch on Red Hat Enterprise Linux.

# Copyright (C) 2009, 2010, 2011, 2012, 2013, 2014, 2015 Nicira, Inc.
#
# Copying and distribution of this file, with or without modification,
# are permitted in any medium without royalty provided the copyright
# notice and this notice are preserved.  This file is offered as-is,
# without warranty of any kind.
#
# If tests have to be skipped while building, specify the '--without check'
# option. For example:
# rpmbuild -bb --without check rhel/openvswitch.spec

Name: openvswitch
Summary: Open vSwitch daemon/database/utilities
Group: System Environment/Daemons
URL: http://www.openvswitch.org/
Vendor: Nicira, Inc.
Version: 2.5.1

License: ASL 2.0
Release: 1
Source: openvswitch-%{version}.orig.tar.gz
Buildroot: /tmp/openvswitch-rpm
Requires: logrotate 
%if %{?rhel}0 > 60
Requires: python >= 2.7
%else
Requires: python27
%endif
BuildRequires: openssl-devel

%bcond_without check

%description
Open vSwitch provides standard network bridging functions and
support for the OpenFlow protocol for remote per-flow control of
traffic.

%prep
%setup -q

%build
./configure --prefix=/usr --sysconfdir=/etc --localstatedir=%{_localstatedir} --enable-ssl
make %{_smp_mflags}

%install
rm -rf %{buildroot}
make install DESTDIR=%{buildroot}

rhel_cp() {
 base=$1
 mode=$2
 dst=%{buildroot}/$(echo $base | sed 's,_,/,g')
 install -D -m $mode rhel/$base $dst
}
rhel_cp etc_init.d_openvswitch 0755
rhel_cp etc_logrotate.d_openvswitch 0644
rhel_cp etc_sysconfig_network-scripts_ifup-ovs 0755
rhel_cp etc_sysconfig_network-scripts_ifdown-ovs 0755
rhel_cp usr_share_openvswitch_scripts_sysconfig.template 0644

# Get rid of stuff we don't want to make RPM happy.
#rm \
#    %{buildroot}/usr/bin/ovs-testcontroller \
#    %{buildroot}/usr/share/man/man8/ovs-testcontroller.8 \
#    %{buildroot}/usr/bin/ovs-test \
#    %{buildroot}/usr/bin/ovs-l3ping \
#    %{buildroot}/usr/share/man/man8/ovs-test.8 \
#    %{buildroot}/usr/share/man/man8/ovs-l3ping.8 \
#    %{buildroot}/usr/sbin/ovs-vlan-bug-workaround \
#    %{buildroot}/usr/share/man/man8/ovs-vlan-bug-workaround.8 \
#    %{buildroot}/usr/bin/ovn-* \
#    %{buildroot}/usr/share/man/man?/ovn-* \
#    %{buildroot}/usr/share/openvswitch/ovn-* \
#    %{buildroot}/usr/share/openvswitch/scripts/ovn-* ||:
(cd "%{buildroot}" && rm -rf usr/lib)
(cd "%{buildroot}" && rm -rf usr/include)

install -d -m 755 %{buildroot}/var/lib/openvswitch

%check
%if %{with check}
    if make check TESTSUITEFLAGS='%{_smp_mflags}' ||
       make check TESTSUITEFLAGS='--recheck'; then :;
    else
        cat tests/testsuite.log
        exit 1
    fi
%endif

%clean
rm -rf %{buildroot}

%post
# Create default or update existing /etc/sysconfig/openvswitch.
SYSCONFIG=/etc/sysconfig/openvswitch
TEMPLATE=/usr/share/openvswitch/scripts/sysconfig.template
if [ ! -e $SYSCONFIG ]; then
    cp $TEMPLATE $SYSCONFIG
else
    for var in $(awk -F'[ :]' '/^# [_A-Z0-9]+:/{print $2}' $TEMPLATE)
    do
        if ! grep $var $SYSCONFIG >/dev/null 2>&1; then
            echo >> $SYSCONFIG
            sed -n "/$var:/,/$var=/p" $TEMPLATE >> $SYSCONFIG
        fi
    done
fi

# Ensure all required services are set to run
/sbin/chkconfig --add openvswitch
/sbin/chkconfig openvswitch on

%preun
if [ "$1" = "0" ]; then     # $1 = 0 for uninstall
    /sbin/service openvswitch stop
    /sbin/chkconfig --del openvswitch
fi

%postun
if [ "$1" = "0" ]; then     # $1 = 0 for uninstall
    rm -f /etc/openvswitch/conf.db
    rm -f /etc/sysconfig/openvswitch
    rm -f /etc/openvswitch/vswitchd.cacert
fi

exit 0

%files
%defattr(-,root,root)
%dir /etc/openvswitch
/etc/bash_completion.d/ovs-appctl-bashcomp.bash
/etc/bash_completion.d/ovs-vsctl-bashcomp.bash
/etc/init.d/openvswitch
%config(noreplace) /etc/logrotate.d/openvswitch
/etc/sysconfig/network-scripts/ifup-ovs
/etc/sysconfig/network-scripts/ifdown-ovs
/usr/bin/ovs-appctl
/usr/bin/ovs-benchmark
/usr/bin/ovs-dpctl
#/usr/bin/ovs-dpctl-top
/usr/bin/ovs-docker
/usr/bin/ovs-ofctl
#/usr/bin/ovs-parse-backtrace
#/usr/bin/ovs-pcap
/usr/bin/ovs-pki
#/usr/bin/ovs-tcpundump
#/usr/bin/ovs-vlan-test
/usr/bin/ovs-vsctl
/usr/bin/ovsdb-client
/usr/bin/ovsdb-tool
/usr/bin/vtep-ctl
/usr/bin/ovn-controller
/usr/bin/ovn-controller-vtep
/usr/bin/ovn-docker-overlay-driver
/usr/bin/ovn-docker-underlay-driver
/usr/bin/ovn-nbctl
/usr/bin/ovn-northd
/usr/bin/ovn-sbctl
/usr/bin/ovs-testcontroller
/usr/sbin/ovs-vlan-bug-workaround
#/usr/sbin/ovs-bugtool
/usr/sbin/ovs-vswitchd
/usr/sbin/ovsdb-server
/usr/share/man/man1/ovs-benchmark.1.gz
/usr/share/man/man1/ovs-pcap.1.gz
/usr/share/man/man1/ovs-tcpundump.1.gz
/usr/share/man/man1/ovsdb-client.1.gz
/usr/share/man/man1/ovsdb-server.1.gz
/usr/share/man/man1/ovsdb-tool.1.gz
/usr/share/man/man5/ovs-vswitchd.conf.db.5.gz
/usr/share/man/man5/vtep.5.gz
/usr/share/man/man8/ovs-appctl.8.gz
#/usr/share/man/man8/ovs-bugtool.8.gz
/usr/share/man/man8/ovs-ctl.8.gz
/usr/share/man/man8/ovs-dpctl.8.gz
/usr/share/man/man8/ovs-dpctl-top.8.gz
/usr/share/man/man8/ovs-ofctl.8.gz
/usr/share/man/man8/ovs-parse-backtrace.8.gz
/usr/share/man/man8/ovs-pki.8.gz
/usr/share/man/man8/ovs-vlan-test.8.gz
/usr/share/man/man8/ovs-vsctl.8.gz
/usr/share/man/man8/ovs-vswitchd.8.gz
/usr/share/man/man8/vtep-ctl.8.gz
/usr/share/man/man5/ovn-nb.5.gz
/usr/share/man/man5/ovn-sb.5.gz
/usr/share/man/man7/ovn-architecture.7.gz
/usr/share/man/man8/ovn-controller-vtep.8.gz
/usr/share/man/man8/ovn-controller.8.gz
/usr/share/man/man8/ovn-ctl.8.gz
/usr/share/man/man8/ovn-nbctl.8.gz
/usr/share/man/man8/ovn-northd.8.gz
/usr/share/man/man8/ovn-sbctl.8.gz
/usr/share/man/man8/ovs-l3ping.8.gz
/usr/share/man/man8/ovs-test.8.gz
/usr/share/man/man8/ovs-testcontroller.8.gz
/usr/share/man/man8/ovs-vlan-bug-workaround.8.gz
/usr/share/openvswitch/ovn-nb.ovsschema
/usr/share/openvswitch/ovn-sb.ovsschema
/usr/share/openvswitch/scripts/ovn-ctl
#/usr/share/openvswitch/bugtool-plugins/
#/usr/share/openvswitch/python/
#/usr/share/openvswitch/scripts/ovs-bugtool-*
/usr/share/openvswitch/scripts/ovs-check-dead-ifs
/usr/share/openvswitch/scripts/ovs-ctl
/usr/share/openvswitch/scripts/ovs-lib
/usr/share/openvswitch/scripts/ovs-save
/usr/share/openvswitch/scripts/ovs-vtep
/usr/share/openvswitch/scripts/sysconfig.template
/usr/share/openvswitch/vswitch.ovsschema
/usr/share/openvswitch/vtep.ovsschema
%doc COPYING DESIGN.md INSTALL.SSL.md NOTICE README.md WHY-OVS.md FAQ.md NEWS
%doc INSTALL.DPDK.md rhel/README.RHEL README-native-tunneling.md
/var/lib/openvswitch
/var/log/openvswitch
